Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4645)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 4646)
@@ -590,15 +561,12 @@
 !--             (Computation of the skewness of w further below)
                 !$ACC ATOMIC
-                sums_l(k,38,tn) = sums_l(k,38,tn) + w(k,j,i)**3 * rmask(j,i,sr) &
-                                                                * flag
-
-                sums_l_etot  = sums_l_etot + &
-                                        0.5_wp * ( u(k,j,i)**2 + v(k,j,i)**2 +  &
-                                        w(k,j,i)**2 )            * rmask(j,i,sr)&
-                                                                 * flag
-
-!
-!--             Computation of the Kolmogorov length scale. Calculation is based
-!--             on gradients of the deviations from the horizontal mean.
+                sums_l(k,38,tn) = sums_l(k,38,tn) + w(k,j,i)**3 * rmask(j,i,sr) * flag
+
+                sums_l_etot  = sums_l_etot + 0.5_wp * ( u(k,j,i)**2 + v(k,j,i)**2 + w(k,j,i)**2 )  &
+                                             * rmask(j,i,sr) * flag
+
+!
+!--             Computation of the Kolmogorov length scale. Calculation is based on gradients of the
+!--             deviations from the horizontal mean.
 !--             Kolmogorov scale at the boundaries (k=0/z=0m and k=nzt+1) is set to zero.
                 IF ( kolmogorov_length_scale .AND. k /= nzb .AND. k /= nzt+1) THEN
@@ -607,50 +575,47 @@
 !
 !--                Calculate components of the fluctuating rate-of-strain tensor
-!--                (0.5*(del u'_i/del x_j + del u'_j/del x_i)) defined in the
-!--                center of each grid box.
-                   du_dx = ( ( u(k,j,i+1) - hom(k,1,1,sr) ) -                  &
+!--                (0.5*(del u'_i/del x_j + del u'_j/del x_i)) defined in the center of each grid
+!--                box.
+                   du_dx = ( ( u(k,j,i+1) - hom(k,1,1,sr) ) -                                      &
                              ( u(k,j,i) - hom(k,1,1,sr) ) ) * ddx
-                   du_dy = 0.25_wp * ddy *                                     &
-                           ( ( u(k,j+1,i) - hom(k,1,1,sr) ) -                  &
-                             ( u(k,j-1,i) - hom(k,1,1,sr) ) +                  &
-                             ( u(k,j+1,i+1) - hom(k,1,1,sr) ) -                &
+                   du_dy = 0.25_wp * ddy *                                                         &
+                           ( ( u(k,j+1,i) - hom(k,1,1,sr) ) -                                      &
+                             ( u(k,j-1,i) - hom(k,1,1,sr) ) +                                      &
+                             ( u(k,j+1,i+1) - hom(k,1,1,sr) ) -                                    &
                              ( u(k,j-1,i+1) - hom(k,1,1,sr) ) )
-                   du_dz = 0.25_wp * ( ( ( u(k+1,j,i) - hom(k+1,1,1,sr) ) -    &
-                                         ( u(k,j,i) - hom(k,1,1,sr) ) ) *      &
-                                        ddzu(k+1) +                            &
-                                       ( ( u(k,j,i) - hom(k,1,1,sr) ) -        &
-                                         ( u(k-1,j,i) - hom(k-1,1,1,sr) ) )*   &
-                                        ddzu(k) +                              &
-                                       ( ( u(k+1,j,i+1) - hom(k+1,1,1,sr) )-   &
-                                         ( u(k,j,i+1) - hom(k,1,1,sr) ) ) *    &
-                                        ddzu(k+1) +                            &
-                                       ( ( u(k,j,i+1) - hom(k,1,1,sr) ) -      &
-                                         ( u(k-1,j,i+1) - hom(k-1,1,1,sr) ) ) *&
-                                        ddzu(k) )
-
-                   dv_dx = 0.25_wp * ddx *                                     &
-                           ( ( v(k,j,i+1) - hom(k,1,2,sr) ) -                  &
-                             ( v(k,j,i-1) - hom(k,1,2,sr) ) +                  &
-                             ( v(k,j+1,i+1) - hom(k,1,2,sr) ) -                &
+                   du_dz = 0.25_wp * ( ( ( u(k+1,j,i) - hom(k+1,1,1,sr) ) -                        &
+                                         ( u(k,j,i) - hom(k,1,1,sr) ) ) *                          &
+                                       ddzu(k+1) +                                                 &
+                                       ( ( u(k,j,i) - hom(k,1,1,sr) ) -                            &
+                                         ( u(k-1,j,i) - hom(k-1,1,1,sr) ) ) *                      &
+                                       ddzu(k) +                                                   &
+                                       ( ( u(k+1,j,i+1) - hom(k+1,1,1,sr) ) -                      &
+                                         ( u(k,j,i+1) - hom(k,1,1,sr) ) ) *                        &
+                                       ddzu(k+1) +                                                 &
+                                       ( ( u(k,j,i+1) - hom(k,1,1,sr) ) -                          &
+                                         ( u(k-1,j,i+1) - hom(k-1,1,1,sr) ) ) *                    &
+                                       ddzu(k) )
+
+                   dv_dx = 0.25_wp * ddx *                                                         &
+                           ( ( v(k,j,i+1) - hom(k,1,2,sr) ) -                                      &
+                             ( v(k,j,i-1) - hom(k,1,2,sr) ) +                                      &
+                             ( v(k,j+1,i+1) - hom(k,1,2,sr) ) -                                    &
                              ( v(k,j+1,i-1) - hom(k,1,2,sr) ) )
-                   dv_dy = ( ( v(k,j+1,i) - hom(k,1,2,sr) ) -                  &
-                             ( v(k,j,i) - hom(k,1,2,sr) ) ) * ddy
-                   dv_dz = 0.25_wp * ( ( ( v(k+1,j,i) - hom(k+1,1,2,sr) ) -    &
-                                         ( v(k,j,i) - hom(k,1,2,sr) ) ) *      &
-                                        ddzu(k+1) +                            &
-                                       ( ( v(k,j,i) - hom(k,1,2,sr) ) -        &
-                                         ( v(k-1,j,i) - hom(k-1,1,2,sr) ) ) *  &
-                                        ddzu(k) +                              &
-                                       ( ( v(k+1,j+1,i) - hom(k+1,1,2,sr) ) -  &
-                                         ( v(k,j+1,i) - hom(k,1,2,sr) ) ) *    &
-                                        ddzu(k+1) +                            &
-                                       ( ( v(k,j+1,i) - hom(k,1,2,sr) ) -      &
-                                         ( v(k-1,j+1,i) - hom(k-1,1,2,sr) ) ) *&
-                                        ddzu(k) )
-
-                   dw_dx = 0.25_wp * ddx * ( w(k,j,i+1) - w(k,j,i-1) +         &
-                                             w(k-1,j,i+1) - w(k-1,j,i-1) )
-                   dw_dy = 0.25_wp * ddy * ( w(k,j+1,i) - w(k,j-1,i) +         &
-                                             w(k-1,j+1,i) - w(k-1,j-1,i) )
+                   dv_dy = ( ( v(k,j+1,i) - hom(k,1,2,sr) ) - ( v(k,j,i) - hom(k,1,2,sr) ) ) * ddy
+                   dv_dz = 0.25_wp * ( ( ( v(k+1,j,i) - hom(k+1,1,2,sr) ) -                        &
+                                         ( v(k,j,i) - hom(k,1,2,sr) ) ) *                          &
+                                       ddzu(k+1) +                                                 &
+                                       ( ( v(k,j,i) - hom(k,1,2,sr) ) -                            &
+                                         ( v(k-1,j,i) - hom(k-1,1,2,sr) ) ) *                      &
+                                       ddzu(k) +                                                   &
+                                       ( ( v(k+1,j+1,i) - hom(k+1,1,2,sr) ) -                      &
+                                         ( v(k,j+1,i) - hom(k,1,2,sr) ) ) *                        &
+                                       ddzu(k+1) +                                                 &
+                                       ( ( v(k,j+1,i) - hom(k,1,2,sr) ) -                          &
+                                         ( v(k-1,j+1,i) - hom(k-1,1,2,sr) ) ) *                    &
+                                       ddzu(k) )
+
+                   dw_dx = 0.25_wp * ddx * ( w(k,j,i+1) - w(k,j,i-1) + w(k-1,j,i+1) - w(k-1,j,i-1) )
+                   dw_dy = 0.25_wp * ddy * ( w(k,j+1,i) - w(k,j-1,i) + w(k-1,j+1,i) - w(k-1,j-1,i) )
                    dw_dz = ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
 
@@ -667,16 +632,14 @@
                    s33 = 0.5_wp * ( dw_dz + dw_dz )
 
-!--                Calculate 3D instantaneous energy dissipation rate after
-!--                Pope (2000): Turbulent flows, p.259. It is defined in the center
-!--                of each grid volume.
-                   dissipation = 2.0_wp * km(k,j,i) *                          &
-                                ( s11*s11 + s21*s21 + s31*s31 +                &
-                                 s12*s12 + s22*s22 + s32*s32 +                 &
-                                s13*s13 + s23*s23 + s33*s33 )
+!--                Calculate 3D instantaneous energy dissipation rate following Pope (2000):
+!--                Turbulent flows, p.259. It is defined in the center of each grid volume.
+                   dissipation = 2.0_wp * km(k,j,i) *                                              &
+                                ( s11*s11 + s21*s21 + s31*s31 +                                    &
+                                  s12*s12 + s22*s22 + s32*s32 +                                    &
+                                  s13*s13 + s23*s23 + s33*s33 )
                    eta         = ( km(k,j,i)**3.0_wp / ( dissipation+1.0E-12 ) )**(1.0_wp/4.0_wp)
 
                    !$ACC ATOMIC
-                   sums_l(k,121,tn) = sums_l(k,121,tn) + eta * rmask(j,i,sr)   &
-                                                                * flag
+                   sums_l(k,121,tn) = sums_l(k,121,tn) + eta * rmask(j,i,sr) * flag
 
 
@@ -685,35 +648,33 @@
              ENDDO !k-loop
 !
-!--          Total and perturbation energy for the total domain (being
-!--          collected in the last column of sums_l). Summation of these
-!--          quantities is seperated from the previous loop in order to
-!--          allow vectorization of that loop.
+!--          Total and perturbation energy for the total domain (being collected in the last column
+!--          of sums_l). Summation of these quantities is seperated from the previous loop in order
+!--          to allow vectorization of that loop.
              !$ACC ATOMIC
              sums_l(nzb+4,pr_palm,tn) = sums_l(nzb+4,pr_palm,tn) + sums_l_etot
 !
 !--          2D-arrays (being collected in the last column of sums_l)
-             IF ( surf_def_h(0)%end_index(j,i) >=                              &
-                  surf_def_h(0)%start_index(j,i) )  THEN
+             IF ( surf_def_h(0)%end_index(j,i) >= surf_def_h(0)%start_index(j,i) )  THEN
                 m = surf_def_h(0)%start_index(j,i)
                 !$ACC ATOMIC
-                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +            &
-                                        surf_def_h(0)%us(m)   * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +          &
-                                        surf_def_h(0)%usws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +          &
-                                        surf_def_h(0)%vsws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +          &
-                                        surf_def_h(0)%ts(m)   * rmask(j,i,sr)
+                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +                                &
+                                           surf_def_h(0)%us(m)   * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +                              &
+                                           surf_def_h(0)%usws(m) * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +                              &
+                                           surf_def_h(0)%vsws(m) * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +                              &
+                                           surf_def_h(0)%ts(m)   * rmask(j,i,sr)
 #ifndef _OPENACC
                 IF ( humidity )  THEN
-                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +     &
-                                            surf_def_h(0)%qs(m)   * rmask(j,i,sr)
+                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +                         &
+                                               surf_def_h(0)%qs(m)   * rmask(j,i,sr)
                 ENDIF
                 IF ( passive_scalar )  THEN
-                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +     &
-                                            surf_def_h(0)%ss(m)   * rmask(j,i,sr)
+                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +                         &
+                                               surf_def_h(0)%ss(m)   * rmask(j,i,sr)
                 ENDIF
 #endif
@@ -721,30 +682,29 @@
 !--             Summation of surface temperature.
                 !$ACC ATOMIC
-                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn)   +      &
-                                            surf_def_h(0)%pt_surface(m) *      &
-                                            rmask(j,i,sr)
+                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn)   +                          &
+                                            surf_def_h(0)%pt_surface(m) * rmask(j,i,sr)
              ENDIF
              IF ( surf_lsm_h%end_index(j,i) >= surf_lsm_h%start_index(j,i) )  THEN
                 m = surf_lsm_h%start_index(j,i)
                 !$ACC ATOMIC
-                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +            &
-                                        surf_lsm_h%us(m)   * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +          &
-                                        surf_lsm_h%usws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +          &
-                                        surf_lsm_h%vsws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +          &
-                                        surf_lsm_h%ts(m)   * rmask(j,i,sr)
+                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +                                &
+                                           surf_lsm_h%us(m)   * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +                              &
+                                           surf_lsm_h%usws(m) * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +                              &
+                                           surf_lsm_h%vsws(m) * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +                              &
+                                           surf_lsm_h%ts(m)   * rmask(j,i,sr)
 #ifndef _OPENACC
                 IF ( humidity )  THEN
-                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +     &
-                                            surf_lsm_h%qs(m)   * rmask(j,i,sr)
+                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +                         &
+                                               surf_lsm_h%qs(m)   * rmask(j,i,sr)
                 ENDIF
                 IF ( passive_scalar )  THEN
-                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +     &
-                                            surf_lsm_h%ss(m)   * rmask(j,i,sr)
+                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +                         &
+                                               surf_lsm_h%ss(m)   * rmask(j,i,sr)
                 ENDIF
 #endif
@@ -752,30 +712,29 @@
 !--             Summation of surface temperature.
                 !$ACC ATOMIC
-                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn)   +      &
-                                            surf_lsm_h%pt_surface(m)    *      &
-                                            rmask(j,i,sr)
+                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn) +                            &
+                                            surf_lsm_h%pt_surface(m) * rmask(j,i,sr)
              ENDIF
              IF ( surf_usm_h%end_index(j,i) >= surf_usm_h%start_index(j,i) )  THEN
                 m = surf_usm_h%start_index(j,i)
                 !$ACC ATOMIC
-                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +            &
-                                        surf_usm_h%us(m)   * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +          &
-                                        surf_usm_h%usws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +          &
-                                        surf_usm_h%vsws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +          &
-                                        surf_usm_h%ts(m)   * rmask(j,i,sr)
+                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +                                &
+                                           surf_usm_h%us(m)   * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +                              &
+                                           surf_usm_h%usws(m) * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +                              &
+                                           surf_usm_h%vsws(m) * rmask(j,i,sr)
+                !$ACC ATOMIC
+                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +                              &
+                                           surf_usm_h%ts(m)   * rmask(j,i,sr)
 #ifndef _OPENACC
                 IF ( humidity )  THEN
-                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +     &
-                                            surf_usm_h%qs(m)   * rmask(j,i,sr)
+                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +                         &
+                                               surf_usm_h%qs(m)   * rmask(j,i,sr)
                 ENDIF
                 IF ( passive_scalar )  THEN
-                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +     &
-                                            surf_usm_h%ss(m)   * rmask(j,i,sr)
+                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +                         &
+                                               surf_usm_h%ss(m) * rmask(j,i,sr)
                 ENDIF
 #endif
@@ -783,7 +742,6 @@
 !--             Summation of surface temperature.
                 !$ACC ATOMIC
-                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn)   +      &
-                                            surf_usm_h%pt_surface(m)    *      &
-                                            rmask(j,i,sr)
+                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn) +                            &
+                                            surf_usm_h%pt_surface(m)  * rmask(j,i,sr)
              ENDIF
           ENDDO !j-loop
@@ -798,6 +756,5 @@
 !--    Computation of statistics when ws-scheme is not used. Else these
 !--    quantities are evaluated in the advection routines.
-       IF ( .NOT. ws_scheme_mom .OR. sr /= 0 .OR. simulated_time == 0.0_wp )   &
-       THEN
+       IF ( .NOT. ws_scheme_mom .OR. sr /= 0 .OR. simulated_time == 0.0_wp )  THEN
           !$OMP DO
           DO  i = nxl, nxr
@@ -812,16 +769,11 @@
                    vst2 = ( v(k,j,i) - hom(k,1,2,sr) )**2
 
-                   sums_l(k,30,tn) = sums_l(k,30,tn) + ust2 * rmask(j,i,sr)    &
-                                                            * flag
-                   sums_l(k,31,tn) = sums_l(k,31,tn) + vst2 * rmask(j,i,sr)    &
-                                                            * flag
-                   sums_l(k,32,tn) = sums_l(k,32,tn) + w2   * rmask(j,i,sr)    &
-                                                            * flag
+                   sums_l(k,30,tn) = sums_l(k,30,tn) + ust2 * rmask(j,i,sr) * flag
+                   sums_l(k,31,tn) = sums_l(k,31,tn) + vst2 * rmask(j,i,sr) * flag
+                   sums_l(k,32,tn) = sums_l(k,32,tn) + w2   * rmask(j,i,sr) * flag
 !
 !--                Perturbation energy
-
-                   sums_l(k,34,tn) = sums_l(k,34,tn) + 0.5_wp *                &
-                                  ( ust2 + vst2 + w2 )      * rmask(j,i,sr)    &
-                                                            * flag
+                   sums_l(k,34,tn) = sums_l(k,34,tn) +                                             &
+                                     0.5_wp * ( ust2 + vst2 + w2 ) * rmask(j,i,sr) * flag
                 ENDDO
              ENDDO
@@ -829,8 +781,7 @@
        ENDIF
 !
-!--    Computaion of domain-averaged perturbation energy. Please note,
-!--    to prevent that perturbation energy is larger (even if only slightly)
-!--    than the total kinetic energy, calculation is based on deviations from
-!--    the horizontal mean, instead of spatial descretization of the advection
+!--    Computaion of domain-averaged perturbation energy. Please note, to prevent that perturbation
+!--    energy is larger (even if only slightly) than the total kinetic energy, calculation is based
+!--    on deviations from the horizontal mean, instead of spatial descretization of the advection
 !--    term.
        !$OMP DO
@@ -849,8 +800,6 @@
 
                 !$ACC ATOMIC
-                sums_l(nzb+5,pr_palm,tn) = sums_l(nzb+5,pr_palm,tn)            &
-                                 + 0.5_wp * ( ust2 + vst2 + w2 )               &
-                                 * rmask(j,i,sr)                               &
-                                 * flag
+                sums_l(nzb+5,pr_palm,tn) = sums_l(nzb+5,pr_palm,tn)                                &
+                                           + 0.5_wp * ( ust2 + vst2 + w2 ) * rmask(j,i,sr) * flag
 
              ENDDO
@@ -861,5 +810,4 @@
 !
 !--    Horizontally averaged profiles of the vertical fluxes
-
        !$OMP DO
        !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k, l, m) &
@@ -873,51 +821,47 @@
           DO  j = nys, nyn
 !
-!--          Subgridscale fluxes (without Prandtl layer from k=nzb,
-!--          oterwise from k=nzb+1)
-!--          NOTE: for simplicity, nzb_diff_s_inner is used below, although
-!--          ----  strictly speaking the following k-loop would have to be
-!--                split up according to the staggered grid.
-!--                However, this implies no error since staggered velocity
-!--                components are zero at the walls and inside buildings.
-!--          Flag 23 is used to mask surface fluxes as well as model-top fluxes,
-!--          which are added further below.
+!--          Subgridscale fluxes (without Prandtl layer from k=nzb, oterwise from k=nzb+1)
+!--          NOTE: for simplicity, nzb_diff_s_inner is used below, although strictly speaking the
+!--          ----  following k-loop would have to be split up according to the staggered grid.
+!--                However, this implies no error since staggered velocity components are zero at
+!--                the walls and inside buildings.
+!--          Flag 23 is used to mask surface fluxes as well as model-top fluxes, which are added
+!--          further below.
              DO  k = nzb, nzt
-                flag = MERGE( 1.0_wp, 0.0_wp,                                  &
-                              BTEST( wall_flags_total_0(k,j,i), 23 ) ) *       &
-                       MERGE( 1.0_wp, 0.0_wp,                                  &
-                              BTEST( wall_flags_total_0(k,j,i), 9  ) )
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 23 ) ) *           &
+                       MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 9  ) )
 !
 !--             Momentum flux w"u"
                 !$ACC ATOMIC
-                sums_l(k,12,tn) = sums_l(k,12,tn) - 0.25_wp * (                &
-                               km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) &
-                                                           ) * (               &
-                                   ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)     &
-                                 + ( w(k,j,i)   - w(k,j,i-1) ) * ddx           &
-                                                           ) * rmask(j,i,sr)   &
-                                         * rho_air_zw(k)                       &
-                                         * momentumflux_output_conversion(k)   &
-                                         * flag
+                sums_l(k,12,tn) = sums_l(k,12,tn) - 0.25_wp * (                                    &
+                                  km(k,j,i) + km(k+1,j,i) + km(k,j,i-1) + km(k+1,j,i-1)            &
+                                                              ) * (                                &
+                                      ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)                      &
+                                    + ( w(k,j,i)   - w(k,j,i-1) ) * ddx                            &
+                                                                  ) * rmask(j,i,sr)                &
+                                            * rho_air_zw(k)                                        &
+                                            * momentumflux_output_conversion(k)                    &
+                                            * flag
 !
 !--             Momentum flux w"v"
                 !$ACC ATOMIC
-                sums_l(k,14,tn) = sums_l(k,14,tn) - 0.25_wp * (                &
-                               km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) &
-                                                           ) * (               &
-                                   ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)     &
-                                 + ( w(k,j,i)   - w(k,j-1,i) ) * ddy           &
-                                                           ) * rmask(j,i,sr)   &
-                                         * rho_air_zw(k)                       &
-                                         * momentumflux_output_conversion(k)   &
-                                         * flag
+                sums_l(k,14,tn) = sums_l(k,14,tn) - 0.25_wp * (                                    &
+                                  km(k,j,i) + km(k+1,j,i) + km(k,j-1,i) + km(k+1,j-1,i)            &
+                                                              ) * (                                &
+                                      ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)                      &
+                                    + ( w(k,j,i)   - w(k,j-1,i) ) * ddy                            &
+                                                                  ) * rmask(j,i,sr)                &
+                                            * rho_air_zw(k)                                        &
+                                            * momentumflux_output_conversion(k)                    &
+                                            * flag
 !
 !--             Heat flux w"pt"
                 !$ACC ATOMIC
-                sums_l(k,16,tn) = sums_l(k,16,tn)                              &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
-                                               * ( pt(k+1,j,i) - pt(k,j,i) )   &
-                                               * rho_air_zw(k)                 &
-                                               * heatflux_output_conversion(k) &
-                                               * ddzu(k+1) * rmask(j,i,sr)     &
+                sums_l(k,16,tn) = sums_l(k,16,tn)                                                  &
+                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
+                                               * ( pt(k+1,j,i) - pt(k,j,i) )                       &
+                                               * rho_air_zw(k)                                     &
+                                               * heatflux_output_conversion(k)                     &
+                                               * ddzu(k+1) * rmask(j,i,sr)                         &
                                                * flag
 
@@ -926,8 +870,8 @@
 #ifndef _OPENACC
                 IF ( ocean_mode )  THEN
-                   sums_l(k,65,tn) = sums_l(k,65,tn)                           &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
-                                               * ( sa(k+1,j,i) - sa(k,j,i) )   &
-                                               * ddzu(k+1) * rmask(j,i,sr)     &
+                   sums_l(k,65,tn) = sums_l(k,65,tn)                                               &
+                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
+                                               * ( sa(k+1,j,i) - sa(k,j,i) )                       &
+                                               * ddzu(k+1) * rmask(j,i,sr)                         &
                                                * flag
                 ENDIF
